<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Recibo Nro : {{ dataSet?.numero }}
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="point_of_sale"
          label="Listado"
          to="/finanzas/recibos/listado"
        />
        <q-btn
          flat
          dense
          icon="attach_money"
          label="Nuevo"
          to="/finanzas/recibos/nuevo"
        />
        <q-btn
          flat
          dense
          icon="arrow_back_ios_new"
          label="Atras"
          href="javascript:history.go(-1)"
        />
      </div>
    </q-toolbar>

    <q-banner
      v-if="dataSet?.eliminado.fecha"
      inline-actions
      rounded
      dark
      class="bg-red q-mt-sm"
    >
      RECIBO ANULADO
      <q-item dark>
        <q-item-section avatar>
          <q-icon color="white" name="money_off" />
        </q-item-section>
        <q-item-section>
          <q-item-label>
            {{ dataSet?.eliminado.motivo }}
          </q-item-label>
        </q-item-section>
        <q-item-section side>
          <q-item-label caption lines="2">
            Fecha: {{ dataSet?.eliminado.fecha }}
          </q-item-label>
          <q-item-label caption lines="2">
            Anulador por: {{ dataSet?.eliminado.persona }}
          </q-item-label>
        </q-item-section>
      </q-item>
    </q-banner>

    <q-card>
      <div class="row q-col-gutter-sm q-mt-sm">
        <div class="col-sm-6 col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section> Organismo emisión: </q-item-section>
              <q-item-section side>
                {{ dataSet?.emitido_organismo }}
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section> Persona emisión: </q-item-section>
              <q-item-section side>
                {{ dataSet?.emitido_persona }}
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section> Fecha emisión: </q-item-section>
              <q-item-section side>
                {{ dataSet?.emitido_fecha }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>

        <div class="col-sm-6 col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section> Fecha: </q-item-section>
              <q-item-section side> {{ dataSet?.fecha }} </q-item-section>
            </q-item>
            <q-item>
              <q-item-section> Total: </q-item-section>
              <q-item-section side>
                <q-chip color="green" text-color="white" square>
                  $ {{ dataSet?.total }}
                </q-chip>
              </q-item-section>
            </q-item>
          </q-list>
        </div>
      </div>
    </q-card>
    <q-toolbar>
      <q-space />
      <q-btn
        v-if="!dataSet?.eliminado.fecha && $isCan('finanzas.recibos.baja')"
        color="red"
        flat
        dense
        icon="money_off"
        label="Anular Recibo"
        @click="anularRecibo()"
      />
    </q-toolbar>
    <q-card class="q-pa-xs">
      <q-item>
        <q-item-section>
          <q-item-label> Concepto: {{ dataSet?.concepto }}</q-item-label>
          <q-item-label caption lines="2">
            Observaciones: {{ dataSet?.observaciones }}
          </q-item-label>
        </q-item-section>
      </q-item>

      <q-list dense padding v-if="dataSet?.evento">
        <q-item>
          <q-item-section>
            <q-item-label> Evento: {{ dataSet?.evento.nombre }}</q-item-label>
            <q-item-label caption lines="2">
              Area: {{ dataSet?.evento.area }}
            </q-item-label>
          </q-item-section>
          <q-item-section side>
            fecha: {{ dataSet?.evento.fecha }}
          </q-item-section>
        </q-item>
      </q-list>
    </q-card>

    <div v-if="dataSet?.detalle.length">
      <div class="text-titulo q-pa-xs">Detalle Recibo</div>
      <q-card>
        <q-markup-table>
          <thead>
            <tr>
              <th class="text-left">Para</th>
              <th class="text-left">Monto</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(detalle, index) in dataSet?.detalle" :key="index">
              <td class="text-left">
                <span v-if="detalle.persona">
                  {{ detalle.persona }} - {{ detalle.organismo }}
                </span>
                <span v-else>{{ detalle.organismo }}</span>
              </td>
              <td class="text-left">${{ detalle.monto }}</td>
            </tr>
          </tbody>
        </q-markup-table>
      </q-card>
    </div>

    <Loading :showing="loading" />
  </q-page>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import Loading from 'src/components/Loading.vue';
import { api } from 'src/boot/axios';
import { AxiosResponse } from 'axios';
import { useRoute } from 'vue-router';
import { useQuasar } from 'quasar';

export default defineComponent({
  name: 'IndexPage',
  components: { Loading },
  setup() {
    const loading = ref(true);
    const $q = useQuasar();

    const route = useRoute();
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    onMounted(() => {
      getRecibo();
    });

    const dataSet = ref();
    function getRecibo() {
      loading.value = true;
      api
        .get('/api/finanzas/recibos/' + uuid)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    function anularRecibo() {
      $q.dialog({
        title: 'Anulacion de recibo',
        message: 'Ingrese el motivo.',
        prompt: {
          model: '',
          isValid: (val) => val.length > 10,
          type: 'text', // optional
        },
        cancel: true,
        persistent: true,
      }).onOk((data: string) => {
        loading.value = true;

        api
          .delete('/api/finanzas/recibos', {
            data: {
              uuid,
              motivo: data,
            },
          })
          .then(() => {
            getRecibo();
            loading.value = false;
          })
          .catch(() => {
            loading.value = false;
          });
      });
    }

    return { loading, dataSet, anularRecibo };
  },
});
</script>
